Index: /LMDZ6/trunk/DefLists/namelist_ecrad
===================================================================
--- /LMDZ6/trunk/DefLists/namelist_ecrad	(revision 4852)
+++ /LMDZ6/trunk/DefLists/namelist_ecrad	(revision 4853)
@@ -52,7 +52,8 @@
  use_aerosols		= false,          ! Include aerosols in radiation calculations?
  n_aerosol_types         = 13,             
- !aerosol_optics_override_file_name = "aerosol_optics_lmdz.nc"
+ !aerosol_optics_override_file_name = "aer_opt_LMDZ_ECCKD.nc",
+ !aerosol_optics_override_file_name = "aer_opt_LMDZ_RRTMG.nc",
  do_save_spectral_flux   = false,          ! Save spectral fluxes in output file?
  do_save_gpoint_flux     = false,          ! Save fluxes per g-point in output file?
- gas_model_name          = "RRTMG-IFS",    ! Gas model: "Monochromatic", *"RRTMG-IFS"*, "RRTMG-PSRAD"
+ gas_model_name          = "ECCKD",    ! Gas model: "Monochromatic", "RRTMG-IFS", "ECCKD"
 /
Index: /LMDZ6/trunk/bld.cfg.ecrad
===================================================================
--- /LMDZ6/trunk/bld.cfg.ecrad	(revision 4852)
+++ /LMDZ6/trunk/bld.cfg.ecrad	(revision 4853)
@@ -35,4 +35,5 @@
 src::ext_src %EXT_SRC
 src::Ocean_skin %SRC_PATH/%PHYS/Ocean_skin
+src::lmdz %RAD/lmdz
 src::radiation %RAD/radiation
 src::ifsrrtm %RAD/ifsrrtm
Index: /LMDZ6/trunk/libf/phylmd/ecrad/CHANGELOG
===================================================================
--- /LMDZ6/trunk/libf/phylmd/ecrad/CHANGELOG	(revision 4852)
+++ /LMDZ6/trunk/libf/phylmd/ecrad/CHANGELOG	(revision 4853)
@@ -15,4 +15,23 @@
 	- Increased security value in single-precision SW
 	  reflectance-transmittance calculation from 1e-12 to 1e-6
+	- Added radiation/ecrad_config.h file to provide site-specific
+	  optimization options as preprocessor parameters
+	- Replaced slow "sum" intrinsic function in McICA and Tripleclouds
+	  solvers with optimized versions for x86-64 and DWD's NEC
+	- Enable different gas optics models for shortwave and longwave:
+	  namelist gas_model_name can still be used, or use
+	  sw_gas_model_name and lw_gas_model_name to specify separate models
+	- Fix the general aerosol optics + RRTMG combination, so that
+	  optical properties correctly weighted by solar or terrestrial
+	  Planck function, rather than unweighted. This changes fluxes by up
+	  to 0.3 W m-2 in SW and 0.03 in LW, heating rates by up to 0.015
+	  K/d in SW and 0.0015 in LW. Reverts bug introduced between git
+	  commits a405cca (5 Dec 2022) and 7182230 (8 Dec 2022).
+	- Added ifs/satur.F90, used in the IFS to compute relative
+	  humidity for aerosol hydration, and the ability to call it from
+	  ecrad_driver.F90, but note that this routine computes saturation
+	  with respect to ice at colder temperatures. If used, the impact on
+	  fluxes is up to around 1 W m-2 in the SW and 0.05 in the LW, and
+	  for heating rates 0.002 K/d in the SW and 0.003 in the LW.
 
 version 1.6.0 (27 April 2023)
Index: /LMDZ6/trunk/libf/phylmd/ecrad/driver/Makefile
===================================================================
--- /LMDZ6/trunk/libf/phylmd/ecrad/driver/Makefile	(revision 4852)
+++ /LMDZ6/trunk/libf/phylmd/ecrad/driver/Makefile	(revision 4853)
@@ -20,4 +20,6 @@
 test_programs: $(TEST_PROGRAMS)
 
+# Link ecrad executable; add "-lifs" if you want to use the "satur"
+# routine in ecrad_driver.F90
 $(EXECUTABLE): $(OBJECTS) ../lib/*.a ecrad_driver.o
 	$(FC) $(FCFLAGS) ecrad_driver.o $(OBJECTS) $(LIBS) -o $(EXECUTABLE)
Index: /LMDZ6/trunk/libf/phylmd/ecrad/driver/ecrad_driver.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/ecrad/driver/ecrad_driver.F90	(revision 4852)
+++ /LMDZ6/trunk/libf/phylmd/ecrad/driver/ecrad_driver.F90	(revision 4853)
@@ -55,4 +55,7 @@
   implicit none
 
+  ! Uncomment this if you want to use the "satur" routine below
+!#include "satur.intfb.h"
+  
   ! The NetCDF file containing the input profiles
   type(netcdf_file)         :: file
@@ -269,7 +272,17 @@
 
   ! Compute saturation with respect to liquid (needed for aerosol
-  ! hydration) call
+  ! hydration) call...
   call thermodynamics%calc_saturation_wrt_liquid(driver_config%istartcol,driver_config%iendcol)
 
+  ! ...or alternatively use the "satur" function in the IFS (requires
+  ! adding -lifs to the linker command line) but note that this
+  ! computes saturation with respect to ice at colder temperatures,
+  ! which is almost certainly incorrect
+  !allocate(thermodynamics%h2o_sat_liq(ncol,nlev))
+  !call satur(driver_config%istartcol, driver_config%iendcol, ncol, 1, nlev, .false., &
+  !     0.5_jprb * (thermodynamics.pressure_hl(:,1:nlev)+thermodynamics.pressure_hl(:,2:nlev)), &
+  !     0.5_jprb * (thermodynamics.temperature_hl(:,1:nlev)+thermodynamics.temperature_hl(:,2:nlev)), &
+  !     thermodynamics%h2o_sat_liq, 2)
+  
   ! Check inputs are within physical bounds, printing message if not
   is_out_of_bounds =     gas%out_of_physical_bounds(driver_config%istartcol, driver_config%iendcol, &
Index: /LMDZ6/trunk/libf/phylmd/ecrad/ifs/Makefile
===================================================================
--- /LMDZ6/trunk/libf/phylmd/ecrad/ifs/Makefile	(revision 4852)
+++ /LMDZ6/trunk/libf/phylmd/ecrad/ifs/Makefile	(revision 4853)
@@ -2,5 +2,5 @@
 	radiation_scheme.F90 radiation_setup.F90 yoerdu.F90 \
 	yomrip.F90 yoephy.F90 yoecld.F90 yoe_spectral_planck.F90 \
-	cloud_overlap_decorr_len.F90 yoerad.F90
+	cloud_overlap_decorr_len.F90 yoerad.F90 yoethf.F90 satur.F90
 
 OBJECTS := $(SOURCES:.F90=.o)
@@ -31,2 +31,3 @@
 cos_sza.o ice_effective_radius.o liquid_effective_radius.o radiation_scheme.o radiation_setup.o: yoerad.o
 yoerad.o: yoe_spectral_planck.o
+satur.o: yoethf.o
Index: /LMDZ6/trunk/libf/phylmd/ecrad/ifs/yoephy.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/ecrad/ifs/yoephy.F90	(revision 4852)
+++ /LMDZ6/trunk/libf/phylmd/ecrad/ifs/yoephy.F90	(revision 4853)
@@ -11,5 +11,5 @@
 
 USE PARKIND1, ONLY : JPRB, JPIM
-USE ISO_C_BINDING
+!USE ISO_C_BINDING
 
 IMPLICIT NONE
Index: /LMDZ6/trunk/libf/phylmd/ecrad/ifsaux/yomcst.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/ecrad/ifsaux/yomcst.F90	(revision 4852)
+++ /LMDZ6/trunk/libf/phylmd/ecrad/ifsaux/yomcst.F90	(revision 4853)
@@ -71,3 +71,6 @@
 REAL(KIND=JPRB), PARAMETER :: RMCCL4 = 153.823_JPRB
 
+REAL(KIND=JPRB), PARAMETER :: RCPD  = 3.5_JPRB*RD
+REAL(KIND=JPRB), PARAMETER :: RLMLT = RLSTT-RLVTT
+
 END MODULE YOMCST
Index: /LMDZ6/trunk/libf/phylmd/ecrad/lmdz/aeropt_5wv_ecrad.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/ecrad/lmdz/aeropt_5wv_ecrad.F90	(revision 4853)
+++ /LMDZ6/trunk/libf/phylmd/ecrad/lmdz/aeropt_5wv_ecrad.F90	(revision 4853)
@@ -0,0 +1,100 @@
+!aeropt_5wv_ecrad.F90 2022-09-20 A. Idelkadi et O. Boucher 
+!
+     SUBROUTINE AEROPT_5WV_ECRAD(istartcol,iendcol,istartlev,iendlev, &
+                                 config,thermodynamics,aerosol)
+
+
+      USE DIMPHY
+      USE aero_mod
+      USE phys_local_var_mod, ONLY: od443aer,od550aer,od865aer
+!                                      dryod550aer, 
+!                                      ec550aer,od550lt1aer,abs550aer
+!        USE phys_output_var_mod, ONLY: dryaod_diag
+!        USE YOMCST, ONLY: RD,RG
+      USE phys_local_var_mod, ONLY: rhcl
+
+      use parkind1,                      only : jprb
+      use radiation_config,              only : config_type
+      use radiation_thermodynamics,      only : thermodynamics_type
+      use radiation_aerosol,             only : aerosol_type
+      use radiation_constants,           only : AccelDueToGravity
+      use radiation_aerosol_optics_data, only : aerosol_optics_type, &
+         &  IAerosolClassUndefined,   IAerosolClassIgnored, &
+         &  IAerosolClassHydrophobic, IAerosolClassHydrophilic
+
+      IMPLICIT NONE
+
+      !---ATTENTION n_mono est a redéfinir proprement
+
+      ! Range of levels over which aerosols are present
+      integer, intent(in) :: istartlev, iendlev, istartcol,iendcol
+      type(config_type), intent(in), target :: config
+      type(thermodynamics_type),intent(in)  :: thermodynamics
+      type(aerosol_type),       intent(in)  :: aerosol
+      type(aerosol_optics_type), pointer :: ao
+
+      ! Loop indices for column, level, g point, band and aerosol type, and relative humidity
+      integer :: jcol, jlev, jtype, irh
+      ! indice wavelength in aerosol_optics_lmdz.nc
+      INTEGER, PARAMETER :: la443 = 1
+      INTEGER, PARAMETER :: la550 = 2
+!      INTEGER, PARAMETER :: la670 = 3
+!      INTEGER, PARAMETER :: la765 = 4
+      INTEGER, PARAMETER :: la865 = 5
+      real(jprb) :: factor
+      ! n_bands_sw
+      real(jprb), dimension(config%aerosol_optics%n_mono_wl) :: od_aerosol_mono, local_od_mono
+
+      !--initialization
+      od443aer = 0.0_jprb
+      od550aer = 0.0_jprb
+      od865aer = 0.0_jprb
+
+      ao => config%aerosol_optics
+
+      ! Loop over level
+     do jlev = istartlev,iendlev
+
+        ! Loop over column
+        do jcol = istartcol,iendcol
+
+          ! Compute relative humidity with respect to liquid
+          ! saturation and the index to the relative-humidity index of
+          ! hydrophilic-aerosol data
+          irh = ao%calc_rh_index(rhcl(jcol,jlev))
+
+          factor = ( thermodynamics%pressure_hl(jcol,jlev+1) &
+               &    -thermodynamics%pressure_hl(jcol,jlev  )  ) &
+               &   / AccelDueToGravity
+
+          ! Reset temporary arrays
+          od_aerosol_mono = 0.0_jprb
+
+          do jtype = 1,config%n_aerosol_types
+            ! Add the optical depth for this aerosol type to the total for all aerosols.  
+            ! Note that the following expressions are array-wise
+            if (ao%iclass(jtype) == IAerosolClassHydrophobic) then
+              local_od_mono = factor * aerosol%mixing_ratio(jcol,jlev,jtype) &
+                   &  * ao%mass_ext_mono_phobic(:,ao%itype(jtype))
+              od_aerosol_mono = od_aerosol_mono + local_od_mono
+            else if (ao%iclass(jtype) == IAerosolClassHydrophilic) then
+              ! Hydrophilic aerosols require the look-up tables to
+              ! be indexed with irh
+              local_od_mono = factor * aerosol%mixing_ratio(jcol,jlev,jtype) &
+                   &  * ao%mass_ext_mono_philic(:,irh,ao%itype(jtype))
+              od_aerosol_mono = od_aerosol_mono + local_od_mono
+            end if
+
+          end do ! Loop over aerosol type
+
+          !--ATTENTION A BIEN FAIRE CORRESPONDRE LES INDICES
+          od443aer(jcol) = od443aer(jcol) + od_aerosol_mono(la443)
+          od550aer(jcol) = od550aer(jcol) + od_aerosol_mono(la550)
+          od865aer(jcol) = od865aer(jcol) + od_aerosol_mono(la865)
+
+        end do ! Loop over column
+
+      end do ! Loop over level
+
+     END SUBROUTINE AEROPT_5WV_ECRAD
+
